!*===========================================================================*
!                                                                            *
!   sflxmll.l   Dialog description for sflxmll.c                             *
!                                                                            *
!   Written:    98/03/15  Jonathan Schultz <jonathan@imatix.com>             *
!   Revised:    98/04/02  Jonathan Schultz <jonathan@imatix.com>             *
!                                                                            *
!   XML file loader.  Copyright (c) 1998 iMatix.                             *
!                                                                            *
!   This program is free software; you can redistribute it and/or modify     *
!   it under the terms of the GNU General Public License as published by     *
!   the Free Software Foundation; either version 2 of the License, or        *
!   (at your option) any later version.                                      *
!                                                                            *
!   This program is distributed in the hope that it will be useful,          *
!   but WITHOUT ANY WARRANTY; without even the implied warranty of           *
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
!   GNU General Public License for more details.                             *
!                                                                            *
!   You should have received a copy of the GNU General Public License        *
!   along with this program; if not, write to the Free Software              *
!   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                *
!*===========================================================================*
-source=sflxmll

After-Init:
    (--) Ok                                 -> Getting-Item
          + Open-XML-File
          + Initialise-XML-Tree
          + Get-Next-Char

Getting-Item:
    (--) Open                               -> Getting-Tag
          + Get-Next-Token
    (--) Char                               -> Getting-Item
          + Confirm-Item-Open
          + Collect-Item-Value
          + Get-Next-Char
    (--) End-Of-File                        ->
          + Confirm-All-Items-Closed
          + Close-XML-File
          + Return-Success-Feedback
          + Terminate-The-Program

Getting-Tag:
    (--) Name                               -> Getting-Attr
          + Attach-New-Item
          + Get-Next-Token
    (--) Slash                              -> Getting-Item
          + Expect-Name
          + Confirm-Item-Name
          + Close-The-Item
          + Expect-Close
          + Get-Next-Char
    (--) Double-Hyphen                      -> Getting-Item
          + Skip-Rest-Of-Comment
          + Expect-Close
          + Get-Next-Char

Getting-Attr:
    (--) Name                               -> Getting-Attr
          + Expect-Equals-Token
          + Expect-Literal
          + Attach-New-Attribute
          + Free-Literal
          + Get-Next-Token
    (--) Close                              -> Getting-Item
          + Get-Next-Char
    (--) Slash                              -> Getting-Item
          + Expect-Close
          + Close-The-Item
          + Get-Next-Char

Defaults:
    (--) Option                             ->
          + Process-Option-Value
          + Get-Next-Token
    (--) Error                              ->
          + Close-XML-File
          + Free-Partial-XML-Tree
          + Return-Error-Feedback
          + Terminate-The-Program
    (--) $other                             ->
          + Unexpected-Token-Error
