!----------------------------------------------------------------------------
!   Name:       xiadmin.l
!   Title:      Dialog for Xitami administration agent
!   Package:    Xitami
!
!   Written:    97/08/03  Pieter Hintjens <ph@imatix.com>
!   Revised:    98/03/30  Pieter Hintjens <ph@imatix.com>
!
!   Copyright:  Copyright (c) 1997 iMatix
!   License:    To be defined.
!----------------------------------------------------------------------------
-schema=smtschm.c
-idle
-nosort
-stats

After-Init:
    (--) Ok                                 -> Start-Session
          +

Start-Session:
    (--) Ok                                 -> Select-Initial
          + Determine-Initial-Screen

Select-Initial:
    (--) Main                               -> Main-Menu
          + Open-Main-Admin-Menu
          + Show-Main-Admin-Menu
          + Decode-Http-Request-Reponse
    (--) Basic                              -> Config-Server
          + Use-Defaults-Config-Name
          + Load-Current-Config-File
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Advanced                           -> Config-List
          + Open-Config-List
          + Show-Config-List-First
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Return                             -> Main-Menu
          + Close-All-Forms
          + Open-Main-Admin-Menu
          + Show-Main-Admin-Menu
          + Decode-Http-Request-Reponse

Main-Menu:
    (--) Basic                              -> Config-Server
          + Use-Defaults-Config-Name
          + Load-Current-Config-File
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Advanced                           -> Config-List
          + Open-Config-List
          + Show-Config-List-First
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Wizard                             -> Vhost-Wizard
          + Open-Vhost-Wizard
          + Show-Vhost-Wizard
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Return                             -> Main-Menu
          + Close-All-Forms
          + Open-Main-Admin-Menu
          + Show-Main-Admin-Menu
          + Decode-Http-Request-Reponse

Config-List:
    (--) Enter                              ->
          + Check-Config-List-Livelink
    (--) Ok                                 ->
          + Close-Current-Form
          + Dialog-Return
    (--) Define                             -> Config-Server
          + Check-New-Config-Name
          + Load-Current-Config-File
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Defaults                           -> Config-Server
          + Use-Defaults-Config-Name
          + Load-Current-Config-File
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Basehost                           -> Config-Server
          + Use-Basehost-Config-Name
          + Load-Current-Config-File
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Restart                            ->
          + Restart-Http-Server-Agent
          + Decode-Http-Request-Reponse
    (--) First                              ->
          + Show-Config-List-First
          + Decode-Http-Request-Reponse
    (--) More                               ->
          + Show-Config-List-Next
          + Decode-Http-Request-Reponse
!   Exceptions generated in this state
    (--) Select-Config                      -> Config-Server
          + Load-Current-Config-File
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Reshow-Form                        ->
          + Show-Config-List-First
          + Decode-Http-Request-Reponse
    (--) Return                             ->
          + Show-Config-List-First
          + Decode-Http-Request-Reponse

Config-Server:
    (--) Ok                                 ->
          + Update-Config-Server
          + Save-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Aliases                            -> Config-Value-List
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Aliases
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Vhosts                             -> Config-Value-List
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Vhosts
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Cgi                                -> Config-Cgi
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Cgi
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Ftp                                -> Config-Ftp
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Ftp
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Security                           -> Config-Security
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Security
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Logging                            -> Config-Logging
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Logging
          + Show-Config-Logging
          + Decode-Http-Request-Reponse
    (--) Mimes                              -> Config-Value-List
          + Update-Config-Server
          + Close-Current-Form
          + Open-Config-Mimes
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Defaults                           ->
          + Show-Config-Server-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Errors                             -> Config-Errors
          + Update-Config-Server
          + Open-Config-Errors
          + Show-Config-Errors
          + Decode-Http-Request-Reponse
    (--) Wsx                                -> Config-Server-List
          + Update-Config-Server
          + Open-Config-Wsx
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Filter                             -> Config-Server-List
          + Update-Config-Server
          + Open-Config-Filter
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Test                               ->
          + Update-Config-Server
          + Test-Url-Mapping
          + Reshow-Current-Form
          + Decode-Http-Request-Reponse

Config-Value-List:
    (--) Ok                                 ->
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Save-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Server                             -> Config-Server
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Aliases                            -> Config-Value-List
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Aliases
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Vhosts                             -> Config-Value-List
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Vhosts
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Cgi                                -> Config-Cgi
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Cgi
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Ftp                                -> Config-Ftp
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Ftp
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Security                           -> Config-Security
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Security
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Logging                            -> Config-Logging
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Logging
          + Show-Config-Logging
          + Decode-Http-Request-Reponse
    (--) Mimes                              -> Config-Value-List
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Open-Config-Mimes
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Clear                              ->
          + Clear-Config-Value-List
          + Reshow-Current-Form
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) First                              ->
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) More                               ->
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Show-Config-Value-List-Next
          + Decode-Http-Request-Reponse

Config-Server-List:  <Config-Value-List>
    (--) Ok                                 -> Config-Server
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Server
          + Close-Current-Form
          + Show-Config-Server
          + Decode-Http-Request-Reponse

Config-Errors:
    (--) Ok                                 -> Config-Server
          + Update-Config-Errors
          + Close-Current-Form
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Server
          + Close-Current-Form
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Defaults                           ->
          + Show-Config-Errors-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Errors
          + Decode-Http-Request-Reponse

Config-Cgi:
    (--) Ok                                 ->
          + Update-Config-Cgi
          + Save-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Server                             -> Config-Server
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Aliases                            -> Config-Value-List
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Aliases
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Vhosts                             -> Config-Value-List
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Vhosts
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Ftp                                -> Config-Ftp
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Ftp
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Security                           -> Config-Security
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Security
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Logging                            -> Config-Logging
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Logging
          + Show-Config-Logging
          + Decode-Http-Request-Reponse
    (--) Mimes                              -> Config-Value-List
          + Update-Config-Cgi
          + Close-Current-Form
          + Open-Config-Mimes
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Defaults                           ->
          + Show-Config-Cgi-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Define-Environ                     -> Config-Cgi-Sub-List
          + Update-Config-Cgi
          + Open-Config-Cgi-Envir
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Define-Aliases                     -> Config-Cgi-Sub-List
          + Update-Config-Cgi
          + Open-Config-Cgi-Alias
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse

Config-Cgi-Sub-List:  <Config-Value-List>
    (--) Ok                                 -> Config-Cgi
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Cgi
          + Close-Current-Form
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse

Config-Ftp:
    (--) Ok                                 ->
          + Update-Config-Ftp
          + Save-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Server                             -> Config-Server
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Aliases                            -> Config-Value-List
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Aliases
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Vhosts                             -> Config-Value-List
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Vhosts
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Cgi                                -> Config-Cgi
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Cgi
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Security                           -> Config-Security
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Security
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Logging                            -> Config-Logging
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Logging
          + Show-Config-Logging
          + Decode-Http-Request-Reponse
    (--) Mimes                              -> Config-Value-List
          + Update-Config-Ftp
          + Close-Current-Form
          + Open-Config-Mimes
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Defaults                           ->
          + Show-Config-Ftp-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Define-Users                       -> Config-Ftp-Users
          + Update-Config-Ftp
          + Open-Config-Ftp-Users
          + Show-Config-Ftp-Users-First
          + Decode-Http-Request-Reponse
    (--) Define-Dirs                        -> Config-Ftp-Dirs
          + Update-Config-Ftp
          + Open-Config-Ftp-Dirs
          + Show-Config-Ftp-Dirs-First
          + Decode-Http-Request-Reponse
    (--) Define-Aliases                     -> Config-Ftp-Sub-List
          + Update-Config-Ftp
          + Open-Config-Ftp-Alias
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse

Config-Ftp-Users:  <Config-Value-List>
    (--) Ok                                 -> Config-Ftp
          + Update-Config-Ftp-Users
          + Save-Config-Resource-File
          + Close-Current-Form
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Ftp
          + Cancel-Config-Resource-File
          + Close-Current-Form
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Clear                              ->
          + Clear-Config-Ftp-Users
          + Reshow-Current-Form
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Ftp-Users-First
          + Decode-Http-Request-Reponse
    (--) First                              ->
          + Update-Config-Ftp-Users
          + Show-Config-Ftp-Users-First
          + Decode-Http-Request-Reponse
    (--) More                               ->
          + Update-Config-Ftp-Users
          + Show-Config-Ftp-Users-Next
          + Decode-Http-Request-Reponse

Config-Ftp-Dirs:
    (--) Enter                              ->
          + Check-Ftp-Dir-Livelink
    (--) Define                             -> Config-Ftp-User-List
          + Check-New-Ftp-Dir-Name
          + Open-Config-Ftp-User-List
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) First                              ->
          + Show-Config-Ftp-Dirs-First
          + Decode-Http-Request-Reponse
    (--) More                               ->
          + Show-Config-Ftp-Dirs-Next
          + Decode-Http-Request-Reponse
    (--) Ok                                 -> Config-Ftp
          + Save-Config-Ftp-Dir-File
          + Close-Current-Form
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Ftp
          + Cancel-Config-Ftp-Dir-File
          + Close-Current-Form
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
!   Exceptions generated in this state
    (--) Select-Resource                    -> Config-Ftp-User-List
          + Open-Config-Ftp-User-List
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse

Config-Ftp-User-List:  <Config-Value-List>
    (--) Ok                                 -> Config-Ftp-Dirs
          + Validate-Config-Value-List
          + Update-Config-Ftp-User-List
          + Close-Current-Form
          + Show-Config-Ftp-Dirs-Same
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Ftp-Dirs
          + Close-Current-Form
          + Show-Config-Ftp-Dirs-Same
          + Decode-Http-Request-Reponse

Config-Ftp-Sub-List:  <Config-Value-List>
    (--) Ok                                 -> Config-Ftp
          + Validate-Config-Value-List
          + Update-Config-Value-List
          + Close-Current-Form
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Ftp
          + Close-Current-Form
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse

Config-Security:
    (--) Ok                                 ->
          + Update-Config-Security
          + Save-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Server                             -> Config-Server
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Aliases                            -> Config-Value-List
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Aliases
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Vhosts                             -> Config-Value-List
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Vhosts
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Cgi                                -> Config-Cgi
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Cgi
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Ftp                                -> Config-Ftp
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Ftp
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Logging                            -> Config-Logging
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Logging
          + Show-Config-Logging
          + Decode-Http-Request-Reponse
    (--) Mimes                              -> Config-Value-List
          + Update-Config-Security
          + Close-Current-Form
          + Open-Config-Mimes
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Defaults                           ->
          + Show-Config-Security-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Define                             -> Config-Resources
          + Update-Config-Security
          + Open-Config-Resources
          + Show-Config-Resources-First
          + Decode-Http-Request-Reponse

Config-Resources:
    (--) Enter                              ->
          + Check-Resources-Livelink
    (--) Define                             -> Config-User-List
          + Update-Config-Resources
          + Check-New-Resource-Name
          + Open-Config-User-List
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) First                              ->
          + Update-Config-Resources
          + Show-Config-Resources-First
          + Decode-Http-Request-Reponse
    (--) More                               ->
          + Update-Config-Resources
          + Show-Config-Resources-Next
          + Decode-Http-Request-Reponse
    (--) Ok                                 -> Config-Security
          + Update-Config-Resources
          + Save-Config-Resource-File
          + Close-Current-Form
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Security
          + Cancel-Config-Resource-File
          + Close-Current-Form
          + Show-Config-Security
          + Decode-Http-Request-Reponse
!   Exceptions generated in this state
    (--) Select-Resource                    -> Config-User-List
          + Open-Config-User-List
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse

Config-User-List:  <Config-Value-List>
    (--) Ok                                 -> Config-Resources
          + Update-Config-User-List
          + Close-Current-Form
          + Show-Config-Resources-Same
          + Decode-Http-Request-Reponse
    (--) Cancel                             -> Config-Resources
          + Close-Current-Form
          + Show-Config-Resources-Same
          + Decode-Http-Request-Reponse
    (--) First                              ->
          + Update-Config-Value-List
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) More                               ->
          + Update-Config-Value-List
          + Show-Config-Value-List-Next
          + Decode-Http-Request-Reponse

Config-Logging:
    (--) Ok                                 ->
          + Update-Config-Logging
          + Save-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Server                             -> Config-Server
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Server
          + Show-Config-Server
          + Decode-Http-Request-Reponse
    (--) Aliases                            -> Config-Value-List
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Aliases
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Vhosts                             -> Config-Value-List
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Vhosts
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Cgi                                -> Config-Cgi
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Cgi
          + Show-Config-Cgi
          + Decode-Http-Request-Reponse
    (--) Ftp                                -> Config-Ftp
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Ftp
          + Show-Config-Ftp
          + Decode-Http-Request-Reponse
    (--) Security                           -> Config-Security
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Security
          + Show-Config-Security
          + Decode-Http-Request-Reponse
    (--) Mimes                              -> Config-Value-List
          + Update-Config-Logging
          + Close-Current-Form
          + Open-Config-Mimes
          + Show-Config-Value-List-First
          + Decode-Http-Request-Reponse
    (--) Defaults                           ->
          + Show-Config-Logging-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Config-Logging
          + Decode-Http-Request-Reponse

Console-Panel:
    (--) Ok                                 -> Main-Menu
          + Close-All-Forms
          + Open-Main-Admin-Menu
          + Show-Main-Admin-Menu
          + Decode-Http-Request-Reponse
    (--) Define                             -> Console-Config
          + Use-Defaults-Config-Name
          + Load-Current-Config-File
          + Open-Console-Config
          + Show-Console-Config
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Return                             ->
          + Show-Console-Panel
          + Decode-Http-Request-Reponse
    (--) Messages                           -> Console-Messages
          + Open-Console-Messages
          + Show-Console-Messages
          + Decode-Http-Request-Reponse
    (--) Details                            -> Connection-List
          + Open-Connection-List
          + Show-Connection-List
          + Decode-Http-Request-Reponse
    (--) Restart                            ->
          + Restart-Http-Server-Agent
          + Decode-Http-Request-Reponse
    (--) Refresh                            ->
          + Show-Console-Panel
          + Decode-Http-Request-Reponse
    (--) Clear                              ->
          + Clear-Console-Panel-Statistics
          + Show-Console-Panel
          + Decode-Http-Request-Reponse
    (--) Kill                               ->
          + Shutdown-Http-Server-Agent
          + Decode-Http-Request-Reponse
    (--) Reshow-Form                        ->
          + Show-Console-Panel
          + Decode-Http-Request-Reponse

Console-Messages:
    (--) Ok                                 -> Console-Panel
          + Close-Current-Form
          + Show-Console-Panel
          + Decode-Http-Request-Reponse
    (--) Define                             -> Console-Config
          + Use-Defaults-Config-Name
          + Load-Current-Config-File
          + Open-Console-Config
          + Show-Console-Config
          + Decode-Http-Request-Reponse
          + Dialog-Call
    (--) Return                             ->
          + Show-Console-Messages
          + Decode-Http-Request-Reponse
    (--) Refresh                            ->
          + Show-Console-Messages
          + Decode-Http-Request-Reponse
    (--) Clear                              ->
          + Clear-Console-Messages
          + Show-Console-Messages
          + Decode-Http-Request-Reponse
    (--) Invert                             ->
          + Invert-Console-Data
          + Show-Console-Messages
          + Decode-Http-Request-Reponse
    (--) Reshow-Form                        ->
          + Show-Console-Messages
          + Decode-Http-Request-Reponse

Connection-List:
    (--) Ok                                 -> Console-Panel
          + Close-Current-Form
          + Show-Console-Panel
          + Decode-Http-Request-Reponse
    (--) Refresh                            ->
          + Show-Connection-List
          + Decode-Http-Request-Reponse
    (--) Reshow-Form                        ->
          + Show-Connection-List
          + Decode-Http-Request-Reponse

Console-Config:
    (--) Ok                                 ->
          + Update-Console-Config
          + Save-Current-Config-File
          + Reload-Server-Base-Config
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Cancel-Current-Config-File
          + Close-Current-Form
          + Dialog-Return
    (--) Defaults                           ->
          + Show-Console-Config-Defaults
          + Decode-Http-Request-Reponse
    (--) Undo                               ->
          + Show-Console-Config
          + Decode-Http-Request-Reponse

Vhost-Wizard:
    (--) Define                             ->
          + Validate-Vhost-Definition
          + Create-Vhost-Definition
          + Close-Current-Form
          + Dialog-Return
    (--) Cancel                             ->
          + Close-Current-Form
          + Dialog-Return

Defaults:
    (--) New-Session                        -> Select-Initial
          + Close-All-Forms
          + Determine-Initial-Screen
    (--) Reshow-Form                        ->
          + Reshow-Current-Form
          + Decode-Http-Request-Reponse
    (--) Exception                          ->
          + Reshow-Current-Form
          + Decode-Http-Request-Reponse
    (--) Shutdown                           ->
          + Close-All-Forms
          + Terminate-The-Thread
    (--) Timeout                            ->
          +
!   Generally the same
    (--) Enter                              ->
          + Check-Simple-Livelink
    (--) Main                               -> Main-Menu
          + Close-All-Forms
          + Open-Main-Admin-Menu
          + Show-Main-Admin-Menu
          + Decode-Http-Request-Reponse
    (--) Console                            -> Console-Panel
          + Close-All-Forms
          + Open-Console-Panel
          + Show-Console-Panel
          + Decode-Http-Request-Reponse
